import java.util.*;

/*
   Opt potn slov v textovm souboru,
   ovem tentokrt s pomoc vlastn implementace 
   jednosmrn zetzenho seznamu zaloenho 
   na parametrizovanch tdch.
   Pouit stejn jako v pedchozch ppadech.
   Vhodn pro JDK 5 a vy
*/

/** Prvek seznamu jako parametrizovan tda*/
class Prvek<T>
{
  T data = null;             // data uloen v prvku
  int poet = 0;             // poet vskyt
  Prvek<T> dal = null;     // Odkaz na dal prvek seznamu
  Prvek(){}                  // Konstruktory
  Prvek(T s) {data = s; poet = 1;}
  int obsahuje(T s) {return s.equals(data) ? poet : 0;}
  void setDal(Prvek<T> q){dal = q;}
  Prvek<T> getDal(){return dal;}
  T getData(){return data;}
  void zvtiPoet(){poet++;}
  int getPocet(){return poet;}
}

/** Vlastn implementace seznamu jako parametrizovan tdy */
class Seznam<T>
{
  Prvek<T> hlava = null;
  void pidej(T data)
  {
    if(hlava == null)
    {
      hlava = new Prvek<T>(data);
    }
    else
    {
       Prvek<T> p = hlava, q = null;
       while(p != null)
       {
          if(p.obsahuje(data) > 0)
          {
            p.zvtiPoet();
            return;
          }
          else
          {
            q = p;
            p = p.getDal();
          } // Konec if
       }    // konec while
       q.setDal(new Prvek<T>(data));
    }
  }

  void vpis()
  {
     Prvek<T> p = hlava;
     while(p != null)
     {
       System.out.println(p.getData()+ " " + p.getPocet());
       p = p.getDal();
     }
  }

  void vyprzdni()
  {
        hlava = null;
  }

}

public class Analyztor
{
  static String oddlovae = " .,;!?";

  int peskoOddlovae(String dek, int od) // rad: analyzovan dek, od: index, od kterho se m zat
  {					    // Vrac: index, kde zan nsledujc slovo, nebo -1, jsme-li na konci dku	
    if(od >= dek.length()) return -1;       // Jsme-li na konci dku, vra -1
    while(oddlovae.indexOf(dek.charAt(od))>=0)
    {
     if(++od == dek.length()) return -1;
    }
    return od;
  }



  void analyzuj(String dek, Seznam<String> sezn) // radek: analyzovan dek, sezn: Kontejner, do kterho se maj slova ukldat
  {
    if(dek.equals(""))return;		// Przdn dek ns nezajm
    int i = 0;				// Index znaku v dku
    StringBuffer data = null;		// Sem ulome zskan data
    i = peskoOddlovae(dek, i);	// Najdi zatek dalho slova (-1 == konec dku)
    while(i >= 0)
    {
      data = new StringBuffer("");
      // Penes nsledujc data do instance "data"
      while((i < dek.length()) && (oddlovae.indexOf(dek.charAt(i))==-1)) // Dokud to nen oddlova
      {
        data.append(dek.charAt(i++));
      }
      // Ulo data do slovnku
      String s = new String(data);
      sezn.pidej(s);
      i = peskoOddlovae(dek, i);
    }
  }


  void bh() throws Exception		// Vlastn bh programu
  {
        Seznam<String> slovnik = new Seznam<String>();
        Scanner vstup = new Scanner(System.in);
        String dek = vstup.nextLine();	// Peti 1. dek

        while(dek != null)		// Dokud se ten da
        {
          dek = dek.trim();		// Odstra okrajov mezery
          analyzuj(dek, slovnik);
          dek = vstup.nextLine();	// ti dal dek
        }
        slovnik.vpis();    // Vypi vsledek

  }

  public static void main(String[] s) throws Exception
  { // Vytvo instanci tdy Analyztor a spust pro ni metodu bh()
      Analyztor a = new Analyztor();
      a.bh();
  }
}