/* 
 * Ukzka ten a zpisu dat primitivnch typ.
 * Metoda zapiPoleDoSouboru(int[] a, String jmeno) 
 * pouije jako podkladov proud FileOutputStream, jako filtr
 * pouije DataOutputStream. K vpisu pole a do souboru jmeno
 * pouije metodu writeInt.
 * Metoda natiPoleZeSouboru je podobn, jen pouv proudy 
 * FileInputStream a DataInputStream a metodu readInt.
 */

import java.io.*;
public class Binrn{
  public static void zapiPoleDoSouboru(int[] a, String jmeno)
  throws java.io.IOException
  {
    DataOutputStream vstup = null;
    try{
        File f = new File(jmeno);
        if (!f.exists())
            f.createNewFile();
        vstup = new DataOutputStream(new FileOutputStream(f));
        for (int i = 0; i < a.length; i++)
            vstup.writeInt(a[i]);
    }
    finally
    {
        if(vstup != null)vstup.close();
    }
  }

  public static int[] natiPoleZeSouboru(String jmno)
  throws java.io.IOException
  {
    final int VELIKOST_INT = 4;
    int[] pole = null;
    DataInputStream vstup = null;
    try
    {
        File f = new File(jmno);
        if (!f.exists())
            throw new java.io.IOException("Soubor neexistuje");
        int dlka = (int) f.length() / VELIKOST_INT;
        pole = new int[dlka];
        vstup = new DataInputStream(new FileInputStream(f));
        for (int i = 0, j; i < dlka; i++)
            pole[i] = vstup.readInt();
    }
    finally
    {
        if(vstup != null)vstup.close();
    }
    return pole;
  }

  public static void main(String[] a) throws java.io.IOException
  {
    int[] p = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
    int[] q ;
    String jmeno = "Data.dta";

    zapiPoleDoSouboru(p, jmeno);

    q = natiPoleZeSouboru(jmeno);

    for(int i = 0; i < q.length; i++) System.out.print(q[i]+" ");
  }
}