// Prce s textovm souborem

import java.io.*;
import java.util.*;

public class TextovSoubory {
    public static void vypi(String jmnoSouboru) throws IOException {
        File f = new File(jmnoSouboru);
        PrintWriter pw = new PrintWriter(new FileWriter(f));
        for(int i = 1; i <= 10; i++)
            pw.print(i+ " ");
        pw.println();
        pw.println(Math.PI);        // Ludolfovo slo
        pw.println(Math.E);         // Eulerovo slo
        pw.println("luouk k pern pl belsk dy");
        pw.close();                 // Nezapomenout uzavt!
    }

    public static void nati(String jmnoSouboru)
            throws FileNotFoundException, IOException
    {
        PrintWriter vstup = null;
        Scanner vstup = null;
        Locale star = Locale.getDefault();
        try{
            vstup = new PrintWriter(new OutputStreamWriter(System.out, "Cp852"));
        }
        catch(UnsupportedEncodingException e)
        {
            vstup = new PrintWriter(new OutputStreamWriter(System.out));
        }
        try{
            Locale.setDefault(new Locale("en-US"));
            vstup = new Scanner(new FileInputStream(jmnoSouboru), "Cp1250");
            vstup.println("Cel sla:");
            while(vstup.hasNextInt())
            {
                vstup.print(vstup.nextInt()+" ");
            }
            vstup.println("sla:");
            vstup.flush();
            while(vstup.hasNextDouble())
            {
                vstup.print(vstup.nextDouble()+" ");
            }
            vstup.println("eiky:");
            while(vstup.hasNext())
            {
                vstup.print(vstup.next()+" ");
            }
        }
        finally
        {
            if(vstup != null) vstup.close();
            if(vstup != null) vstup.close();
            Locale.setDefault(star);
        }
    }
    
    public static boolean jeToInt(String s)
    {
        try{
            Integer.parseInt(s);
            return true;
        }
        catch(NumberFormatException e)
        {
            return false;
        }
    }
    public static boolean jeToDouble(String s)
    {
        try{
            Double.parseDouble(s);
            return true;
        }
        catch(NumberFormatException e)
        {
            return false;
        }
    }

    
    public static void natiProudem(String jmnoSouboru) throws
            FileNotFoundException, IOException {
        PrintWriter vstup = null;
        BufferedReader vstup = null;
        ArrayList<Integer> celsla = new ArrayList<Integer>();
        ArrayList<Double> relnsla = new ArrayList<Double>();
        ArrayList<String> etzce = new ArrayList<String>();
        try{
            vstup = new PrintWriter(new OutputStreamWriter(System.out, "Cp852"));      
            vstup = new BufferedReader(new FileReader(jmnoSouboru));
            String dek = null;
            while((dek = vstup.readLine()) != null)
            {
                StringTokenizer analyztor = new StringTokenizer(dek);
                while(analyztor.hasMoreTokens())
                {
                    String s = analyztor.nextToken();
                    if(jeToInt(s)) celsla.add(Integer.parseInt(s));
                    else if(jeToDouble(s)) relnsla.add(Double.parseDouble(s));
                    else etzce.add(s);
                }
            }
            vstup.println("Cel sla: ");
            for(int i: celsla)
                vstup.print(i + " ");
            vstup.println("\nReln sla:");
            for(double x: relnsla)
                vstup.print(x + " ");
            vstup.println("\neiky:");
            for(String s: etzce)
                vstup.print(s + " ");
        }
        finally
        {
            if(vstup != null) vstup.close();
            if(vstup != null) vstup.close();
        }
    }
    public static void main(String[] args) throws IOException {
        vypi("data.txt");
        //nati("data.txt");
        natiProudem("data.txt");
    }
}
