/* Soubor Kap14\07\vokno\Vokno.java
 * Okno programu Pikorky 2.1
 *
 * Okno pedstavuje hrac plochu, sloenou z tlatek
 * poloench na jednom z panel
 * vylepeno o nabdku, kter obsahuje i volby
 */


package vokno;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Vokno extends JFrame {
    final String titulek = "Pikvorky 2.0";
    boolean thneKruh;
    int n = OknoVoleb.HORN_MEZ;
    String obr1 = "S_kriz2.gif";
    String obr2 = "S_kruh2.gif";
    Icon k = new ImageIcon(obr1);
    Icon kruh = new ImageIcon(obr2);
    JLabel textKdoThne = new JLabel("Na tahu je  ");
    JLabel kdoThne = new JLabel();

    JPanel okno;
    JPanel panel1 = new JPanel();
    JPanel panel2 = new JPanel();
    JButton[][] polka = new JButton[n + 1][n + 1];

    JButton posledn = null; // Pamatuje si posledn tah
    Object[] aktulnNastaven = {obr1, obr2, new Integer(n)};
    vokno.OknoVoleb vol = new vokno.OknoVoleb(this, aktulnNastaven);
    BorderLayout bl = new BorderLayout(1, 1);


    JMenuBar pruhNabdky = new JMenuBar();
    JMenu nabdkaHra = new JMenu("Hra");
    JMenuItem hraNov = new JMenuItem("Nov", 'N');
    JMenuItem hraZpt = new JMenuItem("Zpt", 'Z');
    JMenuItem hraKonec = new JMenuItem("Konec", 'K');

    JMenu nabdkaVolby = new JMenu("Volby");
    JMenuItem volbyNastaven = new JMenuItem("Nastaven...", 'N');

    JMenu nabdkaNpovda = new JMenu("Npovda");
    JMenuItem npovdaOProgramu = new JMenuItem("O programu...", 'O');

    public Vokno() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void potenNpovda() {
        thneKruh = false;
        kdoThne.setIcon(thneKruh ? kruh : k);
    }

    private void zmNpovdu() {
        thneKruh = !thneKruh;
        kdoThne.setIcon(thneKruh ? kruh : k);
    }

    private void hracTlatka() {
        panel2.setLayout(new GridLayout(n + 1, n + 1));
        Color barvaOkraje = new Color(0xA0, 0xA0, 0xA0);
        for (int i = 0; i < n + 1; i++) {
            for (int j = 0; j < n + 1; j++) {
                JButton b = new JButton();
                polka[i][j] = b;
                panel2.add(b, null);
                if (i != 0 && j != 0) {
                    b.addActionListener(
                            new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            tlatkoNandejIkonu(e);
                        }
                    });
                }
            }
        }
        for (int i = 1; i < n + 1; i++) {
            polka[i][0].setBackground(barvaOkraje);
            polka[i][0].setText("" + i);
            polka[0][i].setBackground(barvaOkraje);
            polka[0][i].setText("" + (char) ('A' + i - 1));
        }
        polka[0][0].setBackground(barvaOkraje);
    }

    private void nabdky() {
        setJMenuBar(pruhNabdky); // Pipoj nabdkov pruh k oknu

        pruhNabdky.add(nabdkaHra); // Vlo do nj hlavn nabdky
        pruhNabdky.add(nabdkaVolby);
        pruhNabdky.add(nabdkaNpovda);

        nabdkaHra.add(hraNov); // Vlo do jednotlivch nabdek jejich poloky
        nabdkaHra.add(hraZpt);
        nabdkaHra.addSeparator();
        nabdkaHra.add(hraKonec);

        nabdkaVolby.add(volbyNastaven);
        nabdkaNpovda.add(npovdaOProgramu);
        // Registrace poslucha udlost
        hraKonec.addActionListener(new ActionListener() { // Konec
            public void actionPerformed(ActionEvent e) {
                nabdkaKonec_Akce(e);
            }
        });
        hraZpt.addActionListener(new ActionListener() { // Zpt
            public void actionPerformed(ActionEvent e) {
                nabdkaZpt_Akce(e);
            }
        });
        npovdaOProgramu.addActionListener(new ActionListener() { // O programu
            public void actionPerformed(ActionEvent e) {
                nabdkaOProgramu_Akce(e);
            }
        });
        hraNov.addActionListener(new ActionListener() { // Nov hra
            public void actionPerformed(ActionEvent e) {
                nabdkaNov_Akce(e);
            }
        });
        volbyNastaven.addActionListener(new ActionListener() { // Volby
            public void actionPerformed(ActionEvent e) {
                nabdkaVolby_Akce(e);
            }
        });
    }


    private void jbInit() throws Exception {
        setTitle(titulek);
        okno = (JPanel) getContentPane();
        okno.setLayout(bl);
        potenNpovda();
        okno.add(panel1, BorderLayout.NORTH);
        okno.add(panel2, BorderLayout.CENTER);
        panel1.add(textKdoThne, null);
        textKdoThne.setFont(new java.awt.Font("Dialog", 0, 20));
        panel1.add(kdoThne, null);
        panel1.setBackground(new Color(200, 200, 200));
        hracTlatka();
        nabdky();
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                UzavenHlavnhoOkna();
            }
        });
    }

    protected void UzavenHlavnhoOkna()
    {
        dotazAPpadnKonec();
    }

    protected void tlatkoNandejIkonu(ActionEvent e) {
        posledn = (JButton) e.getSource();
        posledn.setIcon(thneKruh ? kruh : k);
        zmNpovdu();
    }

    protected void nabdkaKonec_Akce(AWTEvent e) {
           dotazAPpadnKonec();
    }

    protected void dotazAPpadnKonec() {
        int odpov = JOptionPane.showConfirmDialog(this,
                "Opravdu chce skonit?", titulek, JOptionPane.YES_NO_OPTION);
        if (odpov == JOptionPane.YES_OPTION) {
            System.exit(0);
        }
    }

    protected void nabdkaZpt_Akce(ActionEvent e) {
        if (posledn != null) {
            posledn.setIcon(null);
            posledn = null;
            zmNpovdu();
        }
    }

    protected void nabdkaOProgramu_Akce(ActionEvent e) {
        JOptionPane.showMessageDialog(this,
                "Hrac plocha pro pik(v)orky\n Pikorky software 2001",
                                      "Pikorky 2.0", JOptionPane.PLAIN_MESSAGE,
                                      new ImageIcon("strom.gif"));
    }

    protected void nabdkaNov_Akce(ActionEvent e) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                polka[i + 1][j + 1].setIcon(null);
            }
        }
        potenNpovda();
        posledn = null;
    }

    protected void nabdkaVolby_Akce(ActionEvent e) {
        vol.setVisible(true);
        vol.setLocation(this.getLocation());
        if (vol.getStiskOK()) {
            n = ((Integer) aktulnNastaven[2]).intValue();
            obr1 = (String) aktulnNastaven[0];
            obr2 = (String) aktulnNastaven[1];
            k = new ImageIcon(obr1);
            kruh = new ImageIcon(obr2);
            potenNpovda();
            panel2.removeAll();
            this.repaint();
            hracTlatka();
        }
    }
}
