/*
 * Okno voleb pro program Pikorky 2.1
 * Definuje konstanty udvajc rozmez potu tlatek
 * Umouje zadat nejmn MINIMUM tlatek, nejve HORNI_MEZ
 * Kombinovan seznam nabz hodnoty od DOLNI_MEZ po HORNI_MEZ
 * Okno se po uzaven nezru, pouze skryje
 * Vylepeno o filtr v okn pro volbu souboru
 */

package vokno;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class OknoVoleb extends JDialog
{                                             // Tlatek je vdy n x n
  public static final int DOLN_MEZ = 10;     // Doln mez hodnot zobrazovanch v kombu
  public static final int HORN_MEZ = 20;     // Horn mez hodnot zobrazovanch v kombu
  public static final int MINIMUM = 5;        // Mn tlatek nem smysl
  private boolean stiskOK = false;            // Uzavel uivatel okno stiskem OK?
  Object[] volby = null;                      // Pole voleb
  Object[] rozmry = null;                    // Pole hodnot pro kombo
  JButton ok = new JButton();                 // Tlatka
  JButton storno = new JButton();
  JTextField obrzek1 = new JTextField();     // Editan pole
  JTextField obrzek2 = new JTextField();
  JComboBox kombo = null;                     // Kombo (kombinovan seznam)
  JLabel canc1 = new JLabel();                // Npisy u komponent
  JLabel canc2 = new JLabel();
  JButton voli1 = new JButton();
  JButton voli2 = new JButton();

  public OknoVoleb(Frame vlastnk, Object[] vol) // Konstruktor
        {
                super(vlastnk, "Volby", true);
                volby = vol;
                setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
                    try {
                     jbInit();
                }
                catch(Exception e) {
                    e.printStackTrace();
                }
        }

  public OknoVoleb() {      // Konstruktor (nepouv se, pozstatek prvnho npadu)
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public boolean getStiskOK(){return stiskOK;}  // Jak bylo okno uzaveno

  private void jbInit() throws Exception {    // Inicializace komponent
    this.getContentPane().setLayout(null);
    this.setResizable(false);
    //this.setModal(true);
    this.setSize(new Dimension(448, 300));
    ok.setText("OK");
    storno.setText("Storno");
    ok.setBounds(new Rectangle(30, 230, 110, 30));
    ok.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ok_actionPerformed(e);
      }
    });
    storno.setBounds(new Rectangle(145, 230, 110, 30));
    storno.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        storno_actionPerformed(e);
      }
    });
    obrzek1.setBounds(new Rectangle(30, 35, 353, 30));
    obrzek1.setText((String)volby[0]);
    obrzek2.setText((String)volby[1]);
    obrzek2.setBounds(new Rectangle(30, 70, 353, 30));

    rozmry = new Object[HORN_MEZ-DOLN_MEZ+1];  // Pprava pole zobrazovanch hodnot pro kombo
    for(int i = DOLN_MEZ; i <= HORN_MEZ; i++){
      rozmry[i-DOLN_MEZ] = new Integer(i);
    }

    kombo = new JComboBox(rozmry);
    kombo.setBounds(new Rectangle(30, 160, 87, 26));
    kombo.setEditable(true);

    kombo.setSelectedIndex(rozmry.length-1);

    canc1.setText("Soubor obsahujc znak pro 1., resp. 2. hre:");
    canc1.setBounds(new Rectangle(30, 10, 354, 18));
    canc2.setText("Poet ad a sloupc hracch pol:");
    canc2.setBounds(new Rectangle(32, 126, 306, 17));
    voli1.setText("...");
    voli1.setBounds(new Rectangle(390, 36, 32, 30));
    voli2.setBounds(new Rectangle(391, 71, 32, 30));
    voli2.setText("...");
    voli1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        volba_Akce(e);
      }
    });
    voli2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        volba_Akce(e);
      }
    });
    this.getContentPane().add(ok, null);
    this.getContentPane().add(storno, null);
    this.getContentPane().add(obrzek1, null);
    this.getContentPane().add(obrzek2, null);
    this.getContentPane().add(kombo, null);
    this.getContentPane().add(canc1, null);
    this.getContentPane().add(canc2, null);
    this.getContentPane().add(voli1, null);
    this.getContentPane().add(voli2, null);
  }

  void storno_actionPerformed(ActionEvent e) {  // Odezva na stisk Storno
    stiskOK = false;                            // Nastav pznak
    obrzek1.setText((String)volby[0]);         // Obnov pvodn volby
    obrzek2.setText((String)volby[1]);
    kombo.setSelectedIndex(rozmry.length-1);
    this.setVisible(false);      // Skryj okno
  }

  void ok_actionPerformed(ActionEvent e) {// Odezva na stisk OK
    volby[0] = obrzek1.getText();    // Penes volby
    volby[1] = obrzek2.getText();
    int n = Integer.parseInt(kombo.getSelectedItem().toString());
    n = Math.max(MINIMUM, n);// Poet polek mus bt v rozmez MINIMUM, HORNI_MEZ
    volby[2] = new Integer(Math.min(HORN_MEZ, n));
    stiskOK = true;// Nastav pznak
    this.setVisible(false);// Skryj okno
  }

  // Vnitn tda (jej deklarace je vnoena do tdy OknoVoleb)
  // ** Tda filtru nemus bt vnitn **
  //
  // Tda filtru pro vbr soubor zobrazovanch v dialogovm okn JFileChooser
  // Mus bt potomkem tdy javax.swing.filechooser.FileFilter
  // a mus implementovat veejn pstupnou metodu
  // boolean accept(File f),
  // kter rozhoduje, zda se soubor zobraz
  // Metoda
  // public String getDescription()
  // vrt popis, kter se zobraz v dce pod jmnem souboru (Files of type)
  class Filtr extends javax.swing.filechooser.FileFilter
  {
    private String ppony = ".jpg .png .jpeg .gif"; // Akceptovan ppony
    public boolean accept(File soubor)
    {
      String ppona = getExtension(soubor);
      if(ppony.indexOf(ppona) != -1)return true;
      else return false;
    }
    private String getExtension(File soubor)  // Zsk pponu souboru
    {
      if(soubor != null)
      {
        String jmno = soubor.getName();      // Zsk cel jmno
        int i = jmno.lastIndexOf('.');       // Tekou zan ppona
        if (i > 0 && i < jmno.length()-1)    // Vyjmi pponu a peve ji na mal psmena
         return jmno.substring(i+1).toLowerCase();// zkus ji najt v etzci pripony
      }
      return "";                // Kdy tam nen, vra przdn etzec
    }
    public String getDescription() // Vrt popis
    {
      return "Grafick soubory pro Javu";
    }
  }

  void volba_Akce(ActionEvent e){
   JTextField pole = e.getSource().equals(voli1) ? obrzek1 : obrzek2;

    File soubor = new File(".");

    JFileChooser vyberSoubor = new JFileChooser();
    vyberSoubor.setCurrentDirectory(soubor);
    vyberSoubor.setDialogTitle("Nov symbol hre");
    vyberSoubor.setFileFilter(new Filtr());       // Nastav filtr
    int vsledek = vyberSoubor.showOpenDialog(this);
    if(vsledek == JFileChooser.APPROVE_OPTION)
    {
      pole.setText(vyberSoubor.getSelectedFile().getPath());
    }
  }
}
